#ifndef __utility_h
#define __utility_h
#include <time.h>
/*
* Define a macro that delays for an amount of time proportional
* to the integer parameter. The delay is a CPU delay and does not
* voluntarily yield the processor. This simulates computation.
*/

#define delay_cpu(n)  {\
	int i=0, sum = 0;\
	/* Do some wasteful computations that will not be optimized to nothing */\
	while (i < n) {\
		sum += (i*(n+1) * (n-i)*(n+1));\
                if(sum > sum*sum+4) i+=2; else i++;\
        }\
}
#endif



